#include <stdio.h>
#include  <time.h>

#define max 20

#define ok              0
#define formatoinvalido 1
#define nnegativo       2
#define nmuitogrande    3
#define excessoparam    4

long ndamas(int n);

#define print_usage printf("%s: Uso: %s <# de linhas do tabuleiro>\n",argv[0],argv[0])
int main(int argc,char**argv)
{
  int n; long t,u;
  
  switch(argc){
  case 1: print_usage; return(ok);
  case 2:
    if(sscanf(argv[1],"%d",&n)!=1){
      printf("%s: Formato numerico invalido (%s).\n",argv[0],argv[1]);
      print_usage; return(formatoinvalido);
    }else if(n<1){
      printf("%s: O numero de linhas do tabuleiro deve ser positivo.\n",
	     argv[0]);
      print_usage; return(nnegativo);
    }else if(n>max){
      printf("%s: O numero de linhas do tabuleiro deve ser no maximo %d\n",
	     argv[0],max);
      print_usage; return(nmuitogrande);
    }
    break;
  default:
    printf("%s: Excesso de parametros.\n",argv[0]);
    print_usage; return(excessoparam);
  }
  
  t=time(NULL), u=ndamas(n), t=time(NULL)-t;
  printf("%s: %10ld solution(s) found for n=%2d. ",argv[0],u,n);
  printf("Elapsed time: %ldh%ldmin%ldsec.\n",t/3600,(t%3600)/60,t%60);
  
  return(ok);
}

#define empilha p[++i]=j,c[j]=s[i+j]=d[i-j+k-1]=0,j=-1
#define desempilha j=p[i--],c[j]=s[i+1+j]=d[i+k-j]=1
#define podeempilhar c[j]&&s[i+1+j]&&d[i+k-j]
#define pilhaquasevazia i==0
long ndamas(int n)
{
  if(n>1){
    register int i, j, k=n; long count=0;
    int p[max],c[max],s[2*max-1],d[2*max-1],x;
    for(i=0;i<k;i++) c[i]=1;
    for(i=0,j=2*k-1;i<j;i++) s[i]=d[i]=1;
    for(x=0;x<(k>>1);x++){
      p[0]=x,c[x]=s[x]=d[k-x-1]=0;
      for(i=0,j=-1;;)
	if((++j)<k)
	  if(podeempilhar)
	    if(i<k-2) empilha;
	    else count++;
	  else continue;
	else
	  if(pilhaquasevazia) break;
	  else desempilha;
      c[x]=s[x]=d[k-x-1]=1;
    }
    count=count<<1;
    if(k%2){
      p[0]=k/2,c[k/2]=s[k/2]=d[k-k/2-1]=0;
      for(i=0,j=-1;;)
	if((++j)<k)
	  if(podeempilhar)
	    if(i<k-2) empilha;
	    else count++;
	  else continue;
	else
	  if(pilhaquasevazia) break;
	  else desempilha;
    }
    return(count);
  }else return(1);
}
